#!/usr/bin/env bash

#find /System/Library/CoreServices /System/Applications /Applications /System/Applications/Utilities -maxdepth 1 -name "*.app" | fzf | xargs -I {} open "{}"
#find /System/Applications /Applications /System/Applications/Utilities -maxdepth 1 -name "*.app" | fzf | xargs -I {} open "{}"

cacheDir=${XDG_CACHE_HOME:-"$HOME/.cache"}
configDir=${XDG_CONFIG_HOME:-"$HOME/.config"}/clauncher

cache="$cacheDir/launcher_opts"
historyFile="$cacheDir/launcher_opts_history"

if ! [ -f "$cache" ]; then
	#gfind /System/Applications /Applications /System/Applications/Utilities /System/Library/CoreServices /System/Volumes/Data/Users/slococo/Applications /System/Volumes/Data/Users/slococo/Library/Application\ Support/JetBrains/Toolbox/scripts -maxdepth 1 -name "*.app" -printf "%f\n" | sort -u > "$cache"
	#/Users/slococo/.local/bin/capture.zsh 'open -a ' | sed "s/open -a //" | grep -v -f /Users/slococo/.open_ignore | sed "s/\\\//g" | sed -e "s/\r//g" | sort -u > "$cache"
	# Hack to remove 'open -a':
	#/Users/slococo/.local/bin/capture.zsh 'open -a' | awk -F'-a' '{print $2}' | grep -v -f /Users/slococo/.open_ignore | sed "s/\\\//g" | sed -e "s/\r//g" | sort -u > "$cache"
	#/Users/slococo/.local/bin/capture.zsh 'open -a' | sed 's/.*-a//' | grep -v -f /Users/slococo/.open_ignore | sed "s/\\\//g" | sed -e "s/\r//g" | sort -u > "$cache"
	#/Users/slococo/.local/bin/capture.zsh 'open -a' | sed -e 's/.*-a//' -e  "s/\\\//g" -e "s/\r//g" | grep -v -f /Users/slococo/.open_ignore | (echo "Finder"; cat -) | sort -u > "$cache"
	#/Users/slococo/.local/bin/capture.zsh 'open -a' | sed -e 's/.*-a//' -e  "s/\\\//g" -e "s/\r//g" | grep -v -f /Users/slococo/.open_ignore | (cat /Users/slococo/.open_add; cat -) | sort -u > "$cache"
	#/Users/slococo/.local/bin/capture.zsh 'open -a' | gsed -e 's/.*-a//' -e  "s/\\\//g" -e "s/\r//g" -e '$aFinder' | grep -v -f /Users/slococo/.open_ignore | sort -u > "$cache"
	$configDir/capture.zsh 'open -a' | sed -e 's/.*-a//' -e  "s/\\\//g" -e "s/\r//g" | grep -v -f $configDir/.open_ignore | (cat $configDir/.open_add; cat -) | sort -u > "$cache"
fi

gawk -v histfile=$historyFile '
	BEGIN {
		while( (getline < histfile) > 0 ) {
			sub("^[0-9]+\t","")
			print
			x[$0]=1
		}
	} !x[$0]++ ' "$cache" \
	| fzf -e --tiebreak=index \
	| gawk -v histfile=$historyFile '
		BEGIN {
			FS=OFS="\t"
			while ( (getline < histfile) > 0 ) {
				count=$1
				sub("^[0-9]+\t","")
				fname=$0
				history[fname]=count
			}
			close(histfile)
		}

		{
			history[$0]++
			print
		}

		END {
			if(!NR) exit
			for (f in history)
				print history[f],f | "sort -t '\t' -k1rn >" histfile
		}
	' \
	| xargs -I {} open -a "{}"

# | awk -F "/" '{ print $NF }'


#OLD_PATH="$PATH"
#PATH="$PATH:/System/Applications:/Applications:/System/Applications/Utilities"
#echo "$PATH"
#PATH="$OLD_PATH"
#echo "$PATH"

